"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const RestClient_1 = __importDefault(require("../core/HTTP/RestClient"));
const Workspace_1 = __importDefault(require("../core/Workspace"));
const ora_1 = __importDefault(require("ora"));
const helpers_1 = require("../helpers");
exports.default = async (args) => {
    let workspace;
    let client;
    try {
        workspace = await Workspace_1.default.init(args.workspace, args.disableSSLVerification);
    }
    catch (e) {
        return (0, helpers_1.MissingWorkspaceError)(args.workspace);
    }
    const spinner = (0, ora_1.default)({
        prefixText: `Enabling ${workspace.name} Portal...`,
    });
    spinner.start();
    try {
        client = new RestClient_1.default(workspace.config, workspace.name);
        await client.disablePortal();
        spinner.prefixText = `\t`;
        spinner.text = `'${workspace.name}' Portal Disabled`;
        spinner.succeed();
    }
    catch (e) {
        console.log(e);
        spinner.fail(e.message);
    }
};
