"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Config_1 = __importDefault(require("./Config"));
class WorkspaceConfig extends Config_1.default {
    get name() {
        return this.data.name;
    }
    set name(name) {
        this.data.name = name;
    }
    get description() {
        return this.data.description;
    }
    set description(text) {
        this.data.description = text;
    }
    get kongAdminUrl() {
        return this.data.kong_admin_url;
    }
    set kongAdminUrl(url) {
        this.data['kong_admin_url'] = url;
    }
    get upstream() {
        return this.data.upstream;
    }
    set upstream(url) {
        this.data.upstream = url;
    }
    get headers() {
        return this.data.headers || {};
    }
    set headers(headers) {
        this.data.headers = headers;
    }
    get kongAdminToken() {
        return this.data.kong_admin_token;
    }
    set kongAdminToken(token) {
        this.data['kong_admin_token'] = token;
    }
    set disableSSLVerification(isDisable) {
        this.data['disable_ssl_verification'] = isDisable;
    }
    get disableSSLVerification() {
        return this.data.disable_ssl_verification;
    }
    set ignoreSpecs(isIgnore) {
        this.data['ignore_specs'] = isIgnore;
    }
    get ignoreSpecs() {
        return this.data.ignore_specs;
    }
    set skipPaths(skipPaths) {
        this.data['skip_paths'] = skipPaths;
    }
    get skipPaths() {
        return this.data.skip_paths;
    }
    set maxContentLengthInMb(maxContentLengthInMb) {
        this.data['max_content_length_mb'] = maxContentLengthInMb;
    }
    get maxContentLengthInMb() {
        return this.data.max_content_length_mb;
    }
}
exports.default = WorkspaceConfig;
